type error = 
  | ClashType of string
  | TypeBadArityDecl
  | UnknownType of string
  | WrongArity of string * int
  | SymbAlreadyDefined of string 
  | SymbUndefined of string
  | NotAPropVar of string
  | NotAPredicate of string
  | Unification of Ty.t * Ty.t
  | ShouldBeApply of string
  | WrongNumberofArgs of string
  | ShouldHaveType of Ty.t * Ty.t
  | ShouldHaveTypeIntorReal of Ty.t
  | ShouldHaveTypeProp
  | Notrigger 
  | CannotGeneralize 
  | SyntaxError

exception Error of error * Why_ptree.loc

type tdecl = 
  | Assume of Formula.t * Why_ptree.loc 
  | Query of string * Formula.t * Why_ptree.loc

val file : Why_ptree.file -> tdecl Queue.t

val report : Format.formatter -> error -> unit


